/  find missing semi-colons within functions
/ q findmissing filename


/ APPLICATION

/ Looks for missing semi-colons in a file
/ You are inside a function of a list if either incurlynum > 0 or
/ insquarenum > 0 or inparennum > 0
myparse:{[line]
  endline: count line;
  if[0 = count rtrim line; :line]; / blank lines don't need semi-colons
  if[(ltrim line)[til 2] ~  "/ "; :line]; / comment lines don't need semi-colons
  jj: line ss " / ";
  if[0 < count jj; endline: first jj];
  i: 0;
  while[i < endline;
	if[line[i] = "{"; incurlynum+: 1];
	if[line[i] = "}"; incurlynum-: 1];
	if[line[i] = "("; inparennum+: 1];
	if[line[i] = ")"; inparennum-: 1];
	i+: 1;
   ];
   rline: ltrim reverse line[til endline]; / get last char before comment 
   if[rline[0] = ";"; :line]; / line is ok as is
   if[(incurlynum > 0) | (inparennum = 0);
       :(line til endline),("; "), ((endline) _ line);
   ]; 
   line}



/ EXECUTION

if[0 = count .z.x; 'argerror] / should have a file
file: .z.x[0]

linenum: 0;
incurlynum: 0; / global variable
inparennum: 0; / global variable
a: read0 ` $ (":"),file / read the file
(` $ (":"),file,("out")) 0: myparse each a / parse and output the file
